<?php

/*
Mailboy - A Php/MySQL application that offers a web based interface
to administer an email server. It can be used by the server administrator
as well as the email users.
(c) 2009 Emmanuel Revah - manu-at-manurevah.com
http://manurevah.com/blah/en/pages/mailboy

This file is part of Mailboy.

Mailboy is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Mailboy is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Mailboy.  If not, see <http://www.gnu.org/licenses/>.
*/

/*
	- manage by IPs:
		- REJECT
		- OK

	- add ip_access table in db
		- id (auto)
		- ip
		- state OK/REJECT
		- reason (does not work actually)
		- note

	- make postfix check the db
		- query = SELECT state FROM ip_access WHERE ip = '%s'
		- main.cf (example usage): smtpd_helo_restrictions = permit_mynetworks, check_client_access mysql:/etc/postfix/mysql-ip-access.cf, reject

	- by email
		- REJECT
		- OK
*/


/* IP stuffs */

/* Add an IP */
$content[forms][add_ip][submit] = "submit_add_ip";
$content[forms][add_ip][new_ip] = "new_ip";
$content[forms][add_ip][reject] = "REJECT";
$content[forms][add_ip][accept] = "OK";
if ($_POST[submit_add_ip]) {
	// IF insert to db fails then keep the var
	$content[forms][add_ip][ip] = $_POST[new_ip];
	/* deal with the input to DB
		- is state valide ?
		- is IP a real IP ?
	*/
	if ($_POST[state] != $content[forms][add_ip][reject] AND $_POST[state] != $content[forms][add_ip][accept]) {
		$content[errors][] = "Please chose a state";
	} else {
		$state = $_POST[state];
		if (!preg_match("$reg_ip", $_POST[new_ip])) {
			$content[errors][] = "IP format is incorrect, please fix it.";
		} else {
			$ip = $_POST[new_ip];
			unset($content[forms][add_ip][ip]);
			if ($_POST[note]) {
				$note = mysql_real_escape_string($_POST[note]);
			}
			// insert into mysql here
			mysql_query("INSERT INTO ip_access (`id`, `ip`, `state`, `note`) VALUES (NULL, '$ip', '$state', '$note');");
			if (mysql_error()) {
				$content[errors][] = mysql_error();
			} else {
				$content[status][] = "IP: <strong>$ip</strong> set to \"<strong>$state</strong>\"";
			}
		}
	}
}

/* Delete domain(s) */
$content[forms][del_ip][submit] = "submit_del_ip";
$content[forms][del_ip][del_ip] = "del_ip";
$content[forms][del_ip][del_ip_confirm] = "del_ip_confirm";
if ($_POST[submit_del_ip]) {
	if (am_i_server_admin(4)) {
		if ($_POST[del_ip] AND $_POST[del_ip_confirm]) {
			foreach ($_POST[del_ip] as $k => $v) {
				$get_ip = mysql_query("SELECT ip FROM ip_access WHERE id = $v;");
				$delled_ip = mysql_fetch_assoc($get_ip);
				$deleted_ip = $delled_ip[ip];
				if (!empty($deleted_ip)) {
					$del_q =mysql_query("DELETE FROM `ip_access` WHERE `ip_access`.`id` = $v;");
					if (!mysql_error()) {
						$content[status][] = "IP <strong>$deleted_ip</strong> removed from access list.";
					} else {
						$content[errors][] = mysql_error();
					}
				} else {
					$content[errors][] = "Error finding the IP";
				}
			}
		} else {
			$content[errors][] = "Not enough confirmation boxes have been ticked";
		}
	} else {
		$content[errors][] = "You don't appear to have the right to do that";
	}
}

/* List IPs */
$order_stuff = check_order_by('ip_access');
$content[ips_access_th][th] = $order_stuff[th];
$order_by = $order_stuff[order_by];
$list_allowed_ips = mysql_query("SELECT * FROM ip_access $order_by;");
if ($list_allowed_ips) {
	for ($x=1; $data = mysql_fetch_assoc($list_allowed_ips); $x++) {
		foreach ($data as $k => $v) {
			$content[ips_allowed][$x][$k] = $v;
		}
	}
}


/* Domain / email stuff */

/* Add domain/email */
$content[forms][add_domain][submit] = "submit_add_domain";
$content[forms][add_domain][new_domain] = "new_domain";
$content[forms][add_domain][reject] = "REJECT";
$content[forms][add_domain][accept] = "OK";
if ($_POST[submit_add_domain]) {
	// IF insert to db fails then keep the var
	$content[forms][add_domain][domain] = $_POST[new_domain];
	/* deal with the input to DB
		- is state valid ?
		- is domain a real domain name or email address ?
	*/
	if ($_POST[state] != $content[forms][add_domain][reject] AND $_POST[state] != $content[forms][add_domain][accept]) {
		$content[errors][] = "Please chose a state";
	} else {
		$state = $_POST[state];
		if (!preg_match("$reg_domain_email", $_POST[new_domain])) {
			$content[errors][] = "Domain name or email address is incorrect, please fix it.";
		} else {
			$domain = $_POST[new_domain];
			unset($content[forms][add_domain][domain]);
			if ($_POST[note]) {
				$note = mysql_real_escape_string($_POST[note]);
			}
			// insert into mysql here
			mysql_query("INSERT INTO domain_access (`id`, `domain`, `state`, `note`) VALUES (NULL, '$domain', '$state', '$note');");
			if (mysql_error()) {
				$content[errors][] = mysql_error();
			} else {
				$content[status][] = "Email/Domain: <strong>$domain</strong> set to \"<strong>$state</strong>\"";
			}
		}
	}
}

/* Delete domain(s) */
$content[forms][del_domain][submit] = "submit_del_domain";
$content[forms][del_domain][del_domain] = "del_domain";
$content[forms][del_domain][del_domain_confirm] = "del_domain_confirm";
if ($_POST[submit_del_domain]) {
	if (am_i_server_admin(4)) {
		if ($_POST[del_domain] AND $_POST[del_domain_confirm]) {
			foreach ($_POST[del_domain] as $k => $v) {
				$get_domain_name = mysql_query("SELECT domain FROM domain_access WHERE id = $v;");
				$delled_domain = mysql_fetch_assoc($get_domain_name);
				$deleted_domain = $delled_domain[domain];
				if (!empty($deleted_domain)) {
					$del_q =mysql_query("DELETE FROM `domain_access` WHERE `domain_access`.`id` = $v;");
					if (!mysql_error()) {
						$content[status][] = "Domain/email <strong>$deleted_domain</strong> removed from the access list.";
					} else {
						$content[errors][] = mysql_error();
					}
				} else {
					$content[errors][] = "Error finding the domain";
				}
			}
		} else {
			$content[errors][] = "Not enough confirmation boxes have been ticked";
		}
	} else {
		$content[errors][] = "You don't appear to have the right to do that";
	}
}

/* List domains */
$order_stuff = check_order_by('domain_access');
$content[domains_access_th][th] = $order_stuff[th];
$order_by = $order_stuff[order_by];
$list_domain_access = mysql_query("SELECT * FROM domain_access $order_by;");
if ($list_domain_access) {
	for ($x=1; $data = mysql_fetch_assoc($list_domain_access); $x++) {
		foreach ($data as $k => $v) {
			$content[domain_access][$x][$k] = $v;
		}
	}
}

?>
